package jp.ddo.shigadroid.batterychanger.XXX;
import android.app.Service;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.os.IBinder;
import android.widget.RemoteViews;

//ホームウィジェット
public class BatteryWidget extends AppWidgetProvider {
	private String WidgetService_Class_Name =
			WidgetService.class.getName();
	
	/**
	 * ウィジェット起動時に呼ばれる
	 */
	@Override
	public void onEnabled(Context context) {
		super.onEnabled(context);
		Intent serviceintent = new Intent(context,WidgetService.class);
    	context.startService(serviceintent);
	}

	/**
	 * ウィジェット終了時に呼ばれる
	 */
	@Override
	public void onDeleted(Context context, int[] appWidgetIds) {
		super.onDeleted(context, appWidgetIds);
		Intent serviceintent = new Intent(context,WidgetService.class);
    	context.stopService(serviceintent);
	}
	
    /**
     * 更新時に呼ばれる
     */
    @Override
    public void onUpdate(Context context,
        AppWidgetManager appWidgetManager,int[] appWidgetIds) {
        //ホームウィジェットを処理するサービスの実行
    	super.onUpdate(context, appWidgetManager, appWidgetIds);
    	//もしサービスが終了していたときは再起動する
    	if(!Funcs.isServiceRunning(context, WidgetService_Class_Name)){
    		Intent serviceintent = new Intent(context,WidgetService.class);
        	context.startService(serviceintent);
    	}
    }
    
    /**
     * バッテリー情報を受け取るためサービスを起動
     * @author shigadroid
     *
     */
    public static class WidgetService extends Service {
        @Override
        public void onStart(Intent in, int si) {
        	IntentFilter filter = new IntentFilter();
            filter.addAction(Intent.ACTION_BATTERY_CHANGED);
            registerReceiver(batterychangeReceiver, filter);
        }
        
        @Override
        public IBinder onBind(Intent in) {
            return null;
        }
    }
    /**
     * バッテリー情報を受け取るためのブロードキャストレシーバ
     */
    private static BroadcastReceiver batterychangeReceiver = new BroadcastReceiver() {
    	int level;
        @Override
        public void onReceive(Context context, Intent intent) {
        	String action = intent.getAction();
        	
        	//バッテリー情報を受け取り、ウィジェットの画像を更新する
        	if (action.equals(Intent.ACTION_BATTERY_CHANGED)) {
                level = intent.getIntExtra("level", 0);
                AppWidgetManager awm = AppWidgetManager.getInstance(context);
                ComponentName cn = new ComponentName(context, BatteryWidget.class);
                RemoteViews rv = new RemoteViews(context.getPackageName(), R.layout.batterywidget);
                rv.setImageViewResource(R.id.widgetimage, Funcs.getDrawableId(context, "stat_sys_battery_c_"+level));
                awm.updateAppWidget(cn, rv);
            }
        }
        
    };
}
