package jp.ddo.shigadroid.batterychanger.XXX;

import java.util.List;

import android.app.ActivityManager;
import android.app.ActivityManager.RunningServiceInfo;
import android.content.Context;

public class Funcs {
	
	/**
	 * 起動しているサービスの一覧を取得して、指定されたclass名のサービスが起動しているか調べる
	 * @param context
	 * @param Service_class_name　クラス名
	 * @return　起動しているときは true	起動していないときは false
	 */
    public static boolean isServiceRunning(Context context, String Service_class_name) {
    	//起動しているサービスの一覧を取得する
        ActivityManager activityManager = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);
        List<RunningServiceInfo> services = activityManager.getRunningServices(Integer.MAX_VALUE);
        
        //指定されたclass名があるか検索する
        for (RunningServiceInfo info : services) {
            if (Service_class_name.equals(info.service.getClassName())) {
                return true;
            }
        }
        return false;
    }
    
  	/**
  	 * 指定した名前のR.drawable.* を返す
  	 * @param context
  	 * @param name
  	 * @return
  	 */
  	public static int getDrawableId(Context context, String name){
  		return context.getResources().getIdentifier(name, "drawable", context.getPackageName());
  	}
}
